unit DJTSatLib_TLB;

{$MODE Delphi}

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : $Revision:   1.88.1.0.1.0  $
// File generated on 02/09/2006 08:05:07 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\Davids\Delphi5\Radio\WXtrack\Component-V3\Source\DJTSatLib.tlb (1)
// IID\LCID: {B670A920-E488-11D4-ADE9-00A0CC5AA94A}\0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (E:\WINDOWS\system32\stdole2.tlb)
//   (2) v4.0 StdVCL, (E:\WINDOWS\system32\STDVCL40.DLL)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
interface

uses LCLIntf, LCLType, LMessages, ActiveX, Classes, Graphics, OleServer{, OleCtrls, StdVCL};

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  DJTSatLibMajorVersion = 3;
  DJTSatLibMinorVersion = 6;

  LIBID_DJTSatLib: TGUID = '{B670A920-E488-11D4-ADE9-00A0CC5AA94A}';

  IID_ISatellites: TGUID = '{B670A922-E488-11D4-ADE9-00A0CC5AA94A}';
  CLASS_Satellites: TGUID = '{664FD442-E48A-11D4-ADE9-00A0CC5AA94A}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  ISatellites = interface;
  ISatellitesDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  Satellites = ISatellites;


// *********************************************************************//
// Interface: ISatellites
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {B670A922-E488-11D4-ADE9-00A0CC5AA94A}
// *********************************************************************//
  ISatellites = interface(IDispatch)
    ['{B670A922-E488-11D4-ADE9-00A0CC5AA94A}']
    function  Get_VersionString: WideString; safecall;
    function  Get_KeplerPath: WideString; safecall;
    procedure Set_KeplerPath(const Value: WideString); safecall;
    function  Get_SatCount: Integer; safecall;
    function  Get_SatNames: WideString; safecall;
    function  Get_ObsLat: Double; safecall;
    procedure Set_ObsLat(Value: Double); safecall;
    function  Get_ObsLon: Double; safecall;
    procedure Set_ObsLon(Value: Double); safecall;
    function  Get_ObsHeight: Double; safecall;
    procedure Set_ObsHeight(Value: Double); safecall;
    function  PassListForPeriod(const Name: WideString; UTCdate: Double; MinSeconds: Integer; 
                                NumDays: Integer; MinElevDegrees: Double): WideString; safecall;
    function  IsVisible(const Name: WideString; JulianTime: Double; ThresholdDeg: Double; 
                        out Southbound: WordBool; out Azumuth: Double; out Elevation: Double; 
                        out Longitude: Double; out Latitude: Double; out Range: Double; 
                        out RangeRate: Double; out Altitude: Double; out Phase: Double): WordBool; safecall;
    function  DateTimeToJT(DateTime: Double): Double; safecall;
    function  Get_RevNumber: Integer; safecall;
    function  Get_OrbitPhase: Double; safecall;
    function  FindAOS(const Name: WideString; PredictTime: Double): Double; safecall;
    function  FindLOS(const Name: WideString; PredictTime: Double): Double; safecall;
    function  Get_MeanAnomaly: Double; safecall;
    procedure SatState(out X: Double; out Y: Double; out Z: Double; out Xdot: Double; 
                       out Ydot: Double; out Zdot: Double); safecall;
    function  Period(const Name: WideString): Double; safecall;
    procedure KeplerData(const Name: WideString; out JulianEpoch: Double; out Inclination: Double; 
                         out RAAN: Double; out Eccentricity: Double; out ArgOfPerigee: Double; 
                         out DecayRate: Double; out Period: Double; out MeanAnomaly: Double); safecall;
    function  MakePassDetails(const PassDescription: WideString; StepSeconds: Integer): WideString; safecall;
    function  Get_IgnoreRefraction: WordBool; safecall;
    procedure Set_IgnoreRefraction(Value: WordBool); safecall;
    function  MakePassDetails2(const PassDescription: WideString; StepSeconds: Integer): WideString; safecall;
    property VersionString: WideString read Get_VersionString;
    property KeplerPath: WideString read Get_KeplerPath write Set_KeplerPath;
    property SatCount: Integer read Get_SatCount;
    property SatNames: WideString read Get_SatNames;
    property ObsLat: Double read Get_ObsLat write Set_ObsLat;
    property ObsLon: Double read Get_ObsLon write Set_ObsLon;
    property ObsHeight: Double read Get_ObsHeight write Set_ObsHeight;
    property RevNumber: Integer read Get_RevNumber;
    property OrbitPhase: Double read Get_OrbitPhase;
    property MeanAnomaly: Double read Get_MeanAnomaly;
    property IgnoreRefraction: WordBool read Get_IgnoreRefraction write Set_IgnoreRefraction;
  end;

// *********************************************************************//
// DispIntf:  ISatellitesDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {B670A922-E488-11D4-ADE9-00A0CC5AA94A}
// *********************************************************************//
  ISatellitesDisp = dispinterface
    ['{B670A922-E488-11D4-ADE9-00A0CC5AA94A}']
    property VersionString: WideString readonly dispid 1;
    property KeplerPath: WideString dispid 2;
    property SatCount: Integer readonly dispid 3;
    property SatNames: WideString readonly dispid 4;
    property ObsLat: Double dispid 5;
    property ObsLon: Double dispid 6;
    property ObsHeight: Double dispid 7;
    function  PassListForPeriod(const Name: WideString; UTCdate: Double; MinSeconds: Integer; 
                                NumDays: Integer; MinElevDegrees: Double): WideString; dispid 8;
    function  IsVisible(const Name: WideString; JulianTime: Double; ThresholdDeg: Double; 
                        out Southbound: WordBool; out Azumuth: Double; out Elevation: Double; 
                        out Longitude: Double; out Latitude: Double; out Range: Double; 
                        out RangeRate: Double; out Altitude: Double; out Phase: Double): WordBool; dispid 9;
    function  DateTimeToJT(DateTime: Double): Double; dispid 10;
    property RevNumber: Integer readonly dispid 11;
    property OrbitPhase: Double readonly dispid 12;
    function  FindAOS(const Name: WideString; PredictTime: Double): Double; dispid 13;
    function  FindLOS(const Name: WideString; PredictTime: Double): Double; dispid 14;
    property MeanAnomaly: Double readonly dispid 15;
    procedure SatState(out X: Double; out Y: Double; out Z: Double; out Xdot: Double; 
                       out Ydot: Double; out Zdot: Double); dispid 16;
    function  Period(const Name: WideString): Double; dispid 17;
    procedure KeplerData(const Name: WideString; out JulianEpoch: Double; out Inclination: Double; 
                         out RAAN: Double; out Eccentricity: Double; out ArgOfPerigee: Double; 
                         out DecayRate: Double; out Period: Double; out MeanAnomaly: Double); dispid 18;
    function  MakePassDetails(const PassDescription: WideString; StepSeconds: Integer): WideString; dispid 19;
    property IgnoreRefraction: WordBool dispid 20;
    function  MakePassDetails2(const PassDescription: WideString; StepSeconds: Integer): WideString; dispid 21;
  end;

// *********************************************************************//
// The Class CoSatellites provides a Create and CreateRemote method to          
// create instances of the default interface ISatellites exposed by              
// the CoClass Satellites. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoSatellites = class
    class function Create: ISatellites;
    class function CreateRemote(const MachineName: string): ISatellites;
  end;

implementation

uses ComObj;

class function CoSatellites.Create: ISatellites;
begin
  Result := CreateComObject(CLASS_Satellites) as ISatellites;
end;

class function CoSatellites.CreateRemote(const MachineName: string): ISatellites;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Satellites) as ISatellites;
end;

end.
